diff --git a/jerry-core/ecma/builtin-objects/ecma-builtin-array-prototype.c b/jerry-core/ecma/builtin-objects/ecma-builtin-array-prototype.c
index 0f703df4c9..47715afa8d 100644
--- a/jerry-core/ecma/builtin-objects/ecma-builtin-array-prototype.c
+++ b/jerry-core/ecma/builtin-objects/ecma-builtin-array-prototype.c
@@ -801,16 +801,14 @@ ecma_builtin_array_prototype_object_slice (ecma_value_t arg1, /**< start */
 {
   uint32_t start = 0, end = len;
 
-  /* 5. */
-  ecma_number_t start_num;
-
-  if (ECMA_IS_VALUE_ERROR (ecma_get_number (arg1, &start_num)))
+  /* 5. 6.*/
+  if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (arg1,
+                                                                      len,
+                                                                      &start)))
   {
     return ECMA_VALUE_ERROR;
   }
 
-  start = ecma_builtin_helper_array_index_normalize (start_num, len, false);
-
   /* 7. */
   if (ecma_is_value_undefined (arg2))
   {
@@ -818,15 +816,13 @@ ecma_builtin_array_prototype_object_slice (ecma_value_t arg1, /**< start */
   }
   else
   {
-    /* 7. part 2 */
-    ecma_number_t end_num;
-
-    if (ECMA_IS_VALUE_ERROR (ecma_get_number (arg2, &end_num)))
+    /* 7. part 2, 8.*/
+    if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (arg2,
+                                                                        len,
+                                                                        &end)))
     {
       return ECMA_VALUE_ERROR;
     }
-
-    end = ecma_builtin_helper_array_index_normalize (end_num, len, false);
   }
 
   JERRY_ASSERT (start <= len && end <= len);
@@ -1189,16 +1185,15 @@ ecma_builtin_array_prototype_object_splice (const ecma_value_t args[], /**< argu
 
   if (args_number > 0)
   {
-    /* 5. */
-    ecma_number_t start_num;
-    if (ECMA_IS_VALUE_ERROR (ecma_get_number (args[0], &start_num)))
+    /* 5. 6. */
+    if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (args[0],
+                                                                        len,
+                                                                        &start)))
     {
       ecma_deref_object (new_array_p);
       return ECMA_VALUE_ERROR;
     }
 
-    start = ecma_builtin_helper_array_index_normalize (start_num, len, false);
-
     /*
      * If there is only one argument, that will be the start argument,
      * and we must delete the additional elements.
@@ -1211,7 +1206,7 @@ ecma_builtin_array_prototype_object_splice (const ecma_value_t args[], /**< argu
     {
       /* 7. */
       ecma_number_t delete_num;
-      if (ECMA_IS_VALUE_ERROR (ecma_get_number (args[1], &delete_num)))
+      if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (args[1], &delete_num)))
       {
         ecma_deref_object (new_array_p);
         return ECMA_VALUE_ERROR;
@@ -1525,8 +1520,8 @@ ecma_builtin_array_prototype_object_unshift (const ecma_value_t args[], /**< arg
  *         Returned value must be freed with ecma_free_value.
  */
 static ecma_value_t
-ecma_builtin_array_prototype_object_index_of (ecma_value_t arg1, /**< searchElement */
-                                              ecma_value_t arg2, /**< fromIndex */
+ecma_builtin_array_prototype_object_index_of (const ecma_value_t args[], /**< arguments list */
+                                              ecma_length_t args_number, /**< number of arguments */
                                               ecma_object_t *obj_p, /**< array object */
                                               uint32_t len) /**< array object's length */
 {
@@ -1537,14 +1532,32 @@ ecma_builtin_array_prototype_object_index_of (ecma_value_t arg1, /**< searchElem
   }
 
   /* 5. */
-  ecma_number_t arg_from_idx;
+  ecma_number_t idx = 0;
+  if (args_number > 1)
+  {
+    if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (args[1], &idx)))
+    {
+      return ECMA_VALUE_ERROR;
+    }
+  }
 
-  if (ECMA_IS_VALUE_ERROR (ecma_get_number (arg2, &arg_from_idx)))
+  /* 6. */
+  if (idx >= len)
   {
-    return ECMA_VALUE_ERROR;
+    return ecma_make_number_value (-1);
   }
 
-  uint32_t from_idx = ecma_builtin_helper_array_index_normalize (arg_from_idx, len, false);
+  /* 7. */
+  ecma_number_t from_idx_num = idx;
+
+  /* 8. */
+  if (idx < 0)
+  {
+    from_idx_num = JERRY_MAX ((ecma_number_t) len + idx, 0);
+  }
+
+  JERRY_ASSERT (from_idx_num >= 0 && from_idx_num <= UINT32_MAX);
+  uint32_t from_idx = (uint32_t) from_idx_num;
 
   if (ecma_op_object_is_fast_array (obj_p))
   {
@@ -1557,7 +1570,7 @@ ecma_builtin_array_prototype_object_index_of (ecma_value_t arg1, /**< searchElem
 
       while (from_idx < len)
       {
-        if (ecma_op_strict_equality_compare (arg1, buffer_p[from_idx]))
+        if (ecma_op_strict_equality_compare (args[0], buffer_p[from_idx]))
         {
           return ecma_make_uint32_value (from_idx);
         }
@@ -1569,6 +1582,7 @@ ecma_builtin_array_prototype_object_index_of (ecma_value_t arg1, /**< searchElem
     }
   }
 
+  /* 6. */
   while (from_idx < len)
   {
     /* 9.a */
@@ -1581,7 +1595,7 @@ ecma_builtin_array_prototype_object_index_of (ecma_value_t arg1, /**< searchElem
 
     /* 9.b.i, 9.b.ii */
     if (ecma_is_value_found (get_value)
-        && ecma_op_strict_equality_compare (arg1, get_value))
+        && ecma_op_strict_equality_compare (args[0], get_value))
     {
       ecma_free_value (get_value);
       return ecma_make_uint32_value (from_idx);
@@ -1616,17 +1630,31 @@ ecma_builtin_array_prototype_object_last_index_of (const ecma_value_t args[], /*
     return ecma_make_integer_value (-1);
   }
 
-  uint32_t from_idx = len - 1;
-
+  /* 5. */
+  ecma_number_t idx = (ecma_number_t) len - 1;
   if (args_number > 1)
   {
-    ecma_number_t arg_from_idx;
-    if (ECMA_IS_VALUE_ERROR (ecma_get_number (args[1], &arg_from_idx)))
+    if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (args[1], &idx)))
     {
       return ECMA_VALUE_ERROR;
     }
+  }
 
-    from_idx = ecma_builtin_helper_array_index_normalize (arg_from_idx, len, true);
+  uint32_t from_idx;
+
+  /* 6 */
+  if (idx >= 0)
+  {
+    from_idx = (uint32_t) (JERRY_MIN (idx, len - 1));
+  }
+  else
+  {
+    ecma_number_t k = len + idx;
+    if (k < 0)
+    {
+      return ecma_make_integer_value (-1);
+    }
+    from_idx = (uint32_t) k;
   }
 
   ecma_value_t search_element = (args_number > 0) ? args[0] : ECMA_VALUE_UNDEFINED;
@@ -1646,19 +1674,13 @@ ecma_builtin_array_prototype_object_last_index_of (const ecma_value_t args[], /*
         {
           return ecma_make_uint32_value (from_idx);
         }
-
         from_idx--;
       }
-
       return ecma_make_integer_value (-1);
     }
   }
 
-  /* 8.
-   * We should break from the loop when from_idx < 0. We can still use an uint32_t for from_idx, and check
-   * for an underflow instead. This is safe, because from_idx will always start in [0, len - 1],
-   * and len is in [0, UINT_MAX], so from_idx >= len means we've had an underflow, and should stop.
-   */
+    /* 8. */
   while (from_idx < len)
   {
     /* 8.a */
@@ -2115,57 +2137,33 @@ ecma_builtin_array_prototype_fill (ecma_value_t value, /**< value */
                                    ecma_object_t *obj_p, /**< array object */
                                    uint32_t len) /**< array object's length */
 {
-  /* 5 */
-  ecma_number_t start;
-  ecma_value_t to_number = ecma_op_to_integer (start_val, &start);
-
-  /* 6 */
-  if (ECMA_IS_VALUE_ERROR (to_number))
-  {
-    return to_number;
-  }
-
-  ecma_number_t k;
+  uint32_t k, final;
 
-  /* 7 */
-  if (ecma_number_is_negative (start))
-  {
-    k = JERRY_MAX (((ecma_number_t) len + start), 0);
-  }
-  else
+  /* 5. 6. 7. */
+  if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (start_val,
+                                                                      len,
+                                                                      &k)))
   {
-    k = JERRY_MIN (start, (ecma_number_t) len);
+    return ECMA_VALUE_ERROR;
   }
 
-  /* 8 */
-  ecma_number_t relative_end;
-
+  /* 8. */
   if (ecma_is_value_undefined (end_val))
   {
-    relative_end = (ecma_number_t) len;
+    final = len;
   }
   else
   {
-    to_number = ecma_op_to_integer (end_val, &relative_end);
-
-    if (ECMA_IS_VALUE_ERROR (to_number))
+    /* 8 part 2, 9, 10 */
+    if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (end_val,
+                                                                        len,
+                                                                        &final)))
     {
-      return to_number;
+      return ECMA_VALUE_ERROR;
     }
   }
 
-  /* 10 */
-  ecma_number_t final;
-  if (relative_end < 0)
-  {
-    final = JERRY_MAX (((ecma_number_t) len + relative_end), 0);
-  }
-  else
-  {
-    final = JERRY_MIN (relative_end, (ecma_number_t) len);
-  }
-
-  /* 11 */
+  /* 11. */
   while (k < final)
   {
     /* 11.a */
@@ -2290,55 +2288,43 @@ ecma_builtin_array_prototype_object_copy_within (const ecma_value_t args[], /**<
     return ecma_copy_value (ecma_make_object_value (obj_p));
   }
 
-  ecma_number_t target_num;
-  ecma_value_t error = ecma_op_to_integer (args[0], &target_num);
+  /* 5 - 7 */
+  uint32_t target;
 
-  if (ECMA_IS_VALUE_ERROR (error))
+  if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (args[0], len, &target)))
   {
-    return error;
+    return ECMA_VALUE_ERROR;
   }
 
-  uint32_t target = (uint32_t) (ecma_number_is_negative (target_num) ? JERRY_MAX (len + target_num, 0) :
-                                                                       JERRY_MIN (target_num, len));
-
   uint32_t start = 0;
   uint32_t end = len;
 
   if (args_number > 1)
   {
-    ecma_number_t start_num;
-    error = ecma_op_to_integer (args[1], &start_num);
-    if (ECMA_IS_VALUE_ERROR (error))
+    /* 8 - 10 */
+    if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (args[1], len, &start)))
     {
-      return error;
+      return ECMA_VALUE_ERROR;
     }
 
-    start = (uint32_t) (ecma_number_is_negative (start_num) ? JERRY_MAX (len + start_num, 0) :
-                                                              JERRY_MIN (start_num, len));
-
     if (args_number > 2)
     {
+      /* 11 */
       if (ecma_is_value_undefined (args[2]))
       {
         end = len;
       }
       else
       {
-        ecma_number_t end_num;
-        error = ecma_op_to_integer (args[2], &end_num);
-        if (ECMA_IS_VALUE_ERROR (error))
+        /* 11 part 2, 12, 13 */
+        if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (args[2], len, &end)))
         {
-          return error;
+          return ECMA_VALUE_ERROR;
         }
-
-        end = (uint32_t) (ecma_number_is_negative (end_num) ? JERRY_MAX (len + end_num, 0) :
-                                                              JERRY_MIN (end_num, len));
       }
     }
   }
 
-  ecma_free_value (error);
-
   uint32_t count = JERRY_MIN (end - start, len - target);
   bool forward = true;
 
@@ -2579,8 +2565,8 @@ ecma_builtin_array_prototype_dispatch_routine (uint16_t builtin_routine_id, /**<
     }
     case ECMA_ARRAY_PROTOTYPE_INDEX_OF:
     {
-      ret_value = ecma_builtin_array_prototype_object_index_of (routine_arg_1,
-                                                                routine_arg_2,
+      ret_value = ecma_builtin_array_prototype_object_index_of (arguments_list_p,
+                                                                arguments_number,
                                                                 obj_p,
                                                                 length);
       break;
diff --git a/jerry-core/ecma/builtin-objects/ecma-builtin-arraybuffer-prototype.c b/jerry-core/ecma/builtin-objects/ecma-builtin-arraybuffer-prototype.c
index f870a245ba..08feedcf2b 100644
--- a/jerry-core/ecma/builtin-objects/ecma-builtin-arraybuffer-prototype.c
+++ b/jerry-core/ecma/builtin-objects/ecma-builtin-arraybuffer-prototype.c
@@ -110,26 +110,28 @@ ecma_builtin_arraybuffer_prototype_object_slice (ecma_value_t this_arg, /**< thi
   ecma_length_t start = 0, end = len;
 
   ecma_value_t ret_value = ECMA_VALUE_EMPTY;
+  ecma_number_t start_num;
 
-  ECMA_OP_TO_NUMBER_TRY_CATCH (start_num,
-                               arg1,
-                               ret_value);
+  if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (arg1, &start_num)))
+  {
+    return ECMA_VALUE_ERROR;
+  }
 
-  start = ecma_builtin_helper_array_index_normalize (start_num, len, false);
+  start = ((start_num < 0) ? (ecma_length_t) JERRY_MAX ((len + start_num), 0)
+                           : (ecma_length_t) JERRY_MIN (start_num, len));
 
   if (!ecma_is_value_undefined (arg2))
   {
-    ECMA_OP_TO_NUMBER_TRY_CATCH (end_num,
-                                 arg2,
-                                 ret_value);
-
-    end = ecma_builtin_helper_array_index_normalize (end_num, len, false);
+    ecma_number_t end_num;
 
-    ECMA_OP_TO_NUMBER_FINALIZE (end_num);
+    if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (arg2, &end_num)))
+    {
+      return ECMA_VALUE_ERROR;
+    }
+    end = ((end_num < 0) ? (ecma_length_t) JERRY_MAX ((len + end_num), 0)
+                         : (ecma_length_t) JERRY_MIN (end_num, len));
   }
 
-  ECMA_OP_TO_NUMBER_FINALIZE (start_num);
-
   if (ret_value != ECMA_VALUE_EMPTY)
   {
     return ret_value;
diff --git a/jerry-core/ecma/builtin-objects/ecma-builtin-helpers.c b/jerry-core/ecma/builtin-objects/ecma-builtin-helpers.c
index b6c25f9c9c..c6832870a9 100644
--- a/jerry-core/ecma/builtin-objects/ecma-builtin-helpers.c
+++ b/jerry-core/ecma/builtin-objects/ecma-builtin-helpers.c
@@ -309,93 +309,43 @@ ecma_builtin_helper_object_get_properties (ecma_object_t *obj_p, /**< object */
 /**
  * Helper function to normalizing an array index
  *
- * This function clamps the given index to the [0, length] range.
- * If the index is negative, it is used as the offset from the end of the array,
- * to compute normalized index.
- * If the index is greater than the length of the array, the normalized index will be the length of the array.
- * If is_last_index_of is true, then we use the method in ECMA-262 v6, 22.2.3.16 to compute the normalized index.
  * See also:
- *          ECMA-262 v5, 15.4.4.10 steps 5-6, 7 (part 2) and 8
- *          ECMA-262 v5, 15.4.4.12 steps 5-6
- *          ECMA-262 v5, 15.4.4.14 steps 5
- *          ECMA-262 v5, 15.5.4.13 steps 4, 5 (part 2) and 6-7
+ *          ECMA-262 v5, 15.4.4.10 steps 5, 6, 7 part 2, 8
+ *          ECMA-262 v5, 15.4.4.12 steps 5, 6
+ *          ECMA-262 v5, 15.5.4.13 steps 4 - 7
+ *          ECMA-262 v6, 22.1.3.6 steps 5 - 7, 8 part 2, 9, 10
+ *          ECMA-262 v6, 22.1.3.3 steps 5 - 10, 11 part 2, 12, 13
+ *          ECMA-262 v6, 22.2.3.5 steps 5 - 10, 11 part 2, 12, 13
+ *          ECMA-262 v6, 22.2.3.23 steps 5 - 10
  *
  * Used by:
  *         - The Array.prototype.slice routine.
  *         - The Array.prototype.splice routine.
- *         - The Array.prototype.indexOf routine.
  *         - The String.prototype.slice routine.
- *         - The TypedArray.prototype.indexOf routine.
- *         - The TypedArray.prototype.lastIndexOf routine
+ *         - The Array.prototype.fill routine.
+ *         - The Array.prototype.copyWithin routine.
+ *         - The TypedArray.prototype.copyWithin routine.
+ *         - The TypedArray.prototype.slice routine.
  *
- * @return uint32_t - the normalized value of the index
+ * @return ECMA_VALUE_EMPTY if successful
+ *         conversion error otherwise
  */
 uint32_t
-ecma_builtin_helper_array_index_normalize (ecma_number_t index, /**< index */
+ecma_builtin_helper_array_index_normalize (ecma_value_t arg, /**< index */
                                            uint32_t length, /**< array's length */
-                                           bool is_last_index_of) /**< true - normalize for lastIndexOf method*/
+                                           uint32_t *number_p) /**< [out] uint32_t */
 {
-  uint32_t norm_index;
-
-  if (!ecma_number_is_nan (index))
-  {
+  ecma_number_t to_int;
 
-    if (ecma_number_is_zero (index))
-    {
-      norm_index = 0;
-    }
-    else if (ecma_number_is_infinity (index))
-    {
-      if (is_last_index_of)
-      {
-        norm_index = ecma_number_is_negative (index) ? (uint32_t) -1 : length - 1;
-      }
-      else
-      {
-        norm_index = ecma_number_is_negative (index) ? 0 : length;
-      }
-    }
-    else
-    {
-      if (ecma_number_is_negative (index))
-      {
-        ecma_number_t index_neg = -index;
-
-        if (is_last_index_of)
-        {
-          norm_index = length - ecma_number_to_uint32 (index_neg);
-        }
-        else
-        {
-          if (index_neg > length)
-          {
-            norm_index = 0;
-          }
-          else
-          {
-            norm_index = length - ecma_number_to_uint32 (index_neg);
-          }
-        }
-      }
-      else
-      {
-        if (index > length)
-        {
-          norm_index = is_last_index_of ? length - 1 : length;
-        }
-        else
-        {
-          norm_index = ecma_number_to_uint32 (index);
-        }
-      }
-    }
-  }
-  else
+  if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (arg, &to_int)))
   {
-    norm_index = 0;
+    return ECMA_VALUE_ERROR;
   }
 
-  return norm_index;
+  *number_p = ((to_int < 0) ? (uint32_t) JERRY_MAX ((length + to_int), 0)
+                            : (uint32_t) JERRY_MIN (to_int, length));
+
+  return ECMA_VALUE_EMPTY;
 } /* ecma_builtin_helper_array_index_normalize */
 
 /**
@@ -569,7 +519,19 @@ ecma_builtin_helper_string_prototype_object_index_of (ecma_string_t *original_st
 
   /* 4 (indexOf, lastIndexOf), 9 (startsWith, includes), 10 (endsWith) */
   ecma_number_t pos_num;
-  ecma_value_t ret_value  = ecma_get_number (arg2, &pos_num);
+  ecma_value_t ret_value;
+#if ENABLED (JERRY_ES2015_BUILTIN)
+  if (mode > ECMA_STRING_LAST_INDEX_OF)
+  {
+    ret_value = ecma_op_to_integer (arg2, &pos_num);
+  }
+  else
+  {
+#endif /* ENABLED (JERRY_ES2015_BUILTIN) */
+    ret_value = ecma_get_number (arg2, &pos_num);
+#if ENABLED (JERRY_ES2015_BUILTIN)
+  }
+#endif /* ENABLED (JERRY_ES2015_BUILTIN) */
 
   /* 10 (startsWith, includes), 11 (endsWith) */
   if (ECMA_IS_VALUE_ERROR (ret_value))
diff --git a/jerry-core/ecma/builtin-objects/ecma-builtin-helpers.h b/jerry-core/ecma/builtin-objects/ecma-builtin-helpers.h
index 10c7ab9605..bf8ae23e47 100644
--- a/jerry-core/ecma/builtin-objects/ecma-builtin-helpers.h
+++ b/jerry-core/ecma/builtin-objects/ecma-builtin-helpers.h
@@ -50,7 +50,7 @@ ecma_builtin_helper_object_get_properties (ecma_object_t *obj_p, uint32_t opts);
 ecma_value_t
 ecma_builtin_helper_array_concat_value (ecma_object_t *obj_p, uint32_t *length_p, ecma_value_t value);
 uint32_t
-ecma_builtin_helper_array_index_normalize (ecma_number_t index, uint32_t length, bool last_index_of);
+ecma_builtin_helper_array_index_normalize (ecma_value_t arg, uint32_t length, uint32_t *number_p);
 uint32_t
 ecma_builtin_helper_string_index_normalize (ecma_number_t index, uint32_t length, bool nan_to_zero);
 ecma_value_t
diff --git a/jerry-core/ecma/builtin-objects/ecma-builtin-json.c b/jerry-core/ecma/builtin-objects/ecma-builtin-json.c
index 32a8ac4bf3..1d4731012b 100644
--- a/jerry-core/ecma/builtin-objects/ecma-builtin-json.c
+++ b/jerry-core/ecma/builtin-objects/ecma-builtin-json.c
@@ -1495,9 +1495,15 @@ ecma_builtin_json_stringify (ecma_value_t this_arg, /**< 'this' argument */
   /* 6. */
   if (ecma_is_value_number (space))
   {
-    ecma_number_t number = ecma_get_number_from_value (space);
     /* 6.a */
-    int32_t num_of_spaces = ecma_number_to_int32 (number);
+    ecma_number_t num_of_spaces;
+
+    if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (space, &num_of_spaces)))
+    {
+      ecma_free_value (space);
+      return ECMA_VALUE_ERROR;
+    }
+
     num_of_spaces = JERRY_MIN (10, num_of_spaces);
 
     /* 6.b */
diff --git a/jerry-core/ecma/builtin-objects/ecma-builtin-number-prototype.c b/jerry-core/ecma/builtin-objects/ecma-builtin-number-prototype.c
index 2fb30e19d7..4946e3e107 100644
--- a/jerry-core/ecma/builtin-objects/ecma-builtin-number-prototype.c
+++ b/jerry-core/ecma/builtin-objects/ecma-builtin-number-prototype.c
@@ -262,7 +262,7 @@ ecma_builtin_number_prototype_object_to_string (ecma_number_t this_arg_number, /
   {
     ecma_number_t arg_num;
 
-    if (ECMA_IS_VALUE_ERROR (ecma_get_number (arguments_list_p[0], &arg_num)))
+    if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (arguments_list_p[0], &arg_num)))
     {
       return ECMA_VALUE_ERROR;
     }
@@ -323,9 +323,9 @@ ecma_builtin_number_prototype_object_to_string (ecma_number_t this_arg_number, /
      */
     magnitude = 0;
     ecma_number_t counter = this_arg_number;
-    while (counter >= radix)
+    while (counter >= (ecma_number_t) radix)
     {
-      counter /= radix;
+      counter /= (ecma_number_t) radix;
       magnitude++;
     }
 
@@ -343,7 +343,7 @@ ecma_builtin_number_prototype_object_to_string (ecma_number_t this_arg_number, /
      * need in the specific radix before we hit a significant digit. This is calculated from the decimal
      * exponent, which we negate so that we get a positive number in the end.
      */
-    magnitude = (int) floor ((log (10) / log (radix)) * -exponent);
+    magnitude = (int) floor ((log (10) / log ((ecma_number_t) radix)) * -exponent);
 
     /*
      * We also need to add space for significant digits. The worst case is radix == 2, since this will
@@ -369,14 +369,14 @@ ecma_builtin_number_prototype_object_to_string (ecma_number_t this_arg_number, /
   {
     for (int i = 0; i < magnitude; i++)
     {
-      this_arg_number /= (ecma_number_t) radix;
+      this_arg_number /= radix;
     }
   }
   else if (exponent < 0)
   {
     for (int i = 0; i < magnitude; i++)
     {
-      this_arg_number *= (ecma_number_t) radix;
+      this_arg_number *= radix;
     }
   }
 
@@ -439,7 +439,7 @@ ecma_builtin_number_prototype_object_to_string (ecma_number_t this_arg_number, /
   /* Calculate digits for fractional part. */
   while (buff_index < required_digits)
   {
-    fraction *= (ecma_number_t) radix;
+    fraction *= radix;
     lit_utf8_byte_t digit = (lit_utf8_byte_t) floor (fraction);
 
     buff[buff_index++] = digit;
@@ -456,13 +456,13 @@ ecma_builtin_number_prototype_object_to_string (ecma_number_t this_arg_number, /
       buff[buff_index - 1]++;
 
       /* Propagate carry forward in the digits. */
-      for (int i = buff_index - 1; i > 0 && buff[i] >= radix; i--)
+      for (int i = buff_index - 1; i > 0 && buff[i] >= (ecma_number_t) radix; i--)
       {
-        buff[i] = (lit_utf8_byte_t) (buff[i] - radix);
+        buff[i] = (lit_utf8_byte_t) (buff[i] - (ecma_number_t) radix);
         buff[i - 1]++;
       }
 
-      if (buff[0] >= radix)
+      if (buff[0] >= (ecma_number_t) radix)
       {
         /*
          * Carry propagated over the whole number, we need to add a new leading digit.
@@ -592,9 +592,9 @@ ecma_builtin_number_prepare_conversion (ecma_number_t *this_num_p, /**< [out] th
   JERRY_ASSERT (mode < NUMBER_ROUTINE__COUNT);
 
   ecma_number_t arg_num;
-  arg_1 = ecma_get_number (arg_1, &arg_num);
+  arg_1 = ecma_op_to_integer (arg_1, &arg_num);
 
-  if (!ecma_is_value_empty (arg_1))
+  if (ECMA_IS_VALUE_ERROR (arg_1))
   {
     return arg_1;
   }
diff --git a/jerry-core/ecma/builtin-objects/ecma-builtin-number.c b/jerry-core/ecma/builtin-objects/ecma-builtin-number.c
index 77caf89691..20bff46fff 100644
--- a/jerry-core/ecma/builtin-objects/ecma-builtin-number.c
+++ b/jerry-core/ecma/builtin-objects/ecma-builtin-number.c
@@ -173,7 +173,12 @@ ecma_builtin_number_object_is_integer (ecma_value_t this_arg, /**< this argument
     return ECMA_VALUE_FALSE;
   }
 
-  ecma_number_t int_num = ecma_number_trunc (num);
+  ecma_number_t int_num;
+
+  if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (arg, &int_num)))
+  {
+    return ECMA_VALUE_ERROR;
+  }
 
   if (int_num != num)
   {
diff --git a/jerry-core/ecma/builtin-objects/ecma-builtin-string-prototype.c b/jerry-core/ecma/builtin-objects/ecma-builtin-string-prototype.c
index f37eab89e1..3614a6a3c0 100644
--- a/jerry-core/ecma/builtin-objects/ecma-builtin-string-prototype.c
+++ b/jerry-core/ecma/builtin-objects/ecma-builtin-string-prototype.c
@@ -151,7 +151,7 @@ ecma_builtin_string_prototype_char_at_helper (ecma_value_t this_arg, /**< this a
 {
   /* 3 */
   ecma_number_t index_num;
-  ecma_value_t to_num_result = ecma_get_number (arg, &index_num);
+  ecma_value_t to_num_result = ecma_op_to_integer (arg, &index_num);
 
   if (JERRY_UNLIKELY (!ecma_is_value_empty (to_num_result)))
   {
@@ -767,18 +767,16 @@ ecma_builtin_string_prototype_object_slice (ecma_string_t *get_string_val, /**<
 {
   const ecma_length_t len = ecma_string_get_length (get_string_val);
 
-  /* 4. */
+  /* 4. 6. */
   ecma_length_t start = 0, end = len;
 
-  ecma_number_t start_num;
-
-  if (ECMA_IS_VALUE_ERROR (ecma_get_number (arg1, &start_num)))
+  if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (arg1,
+                                                                      len,
+                                                                      &start)))
   {
     return ECMA_VALUE_ERROR;
   }
 
-  start = ecma_builtin_helper_array_index_normalize (start_num, len, false);
-
   /* 5. 7. */
   if (ecma_is_value_undefined (arg2))
   {
@@ -786,14 +784,12 @@ ecma_builtin_string_prototype_object_slice (ecma_string_t *get_string_val, /**<
   }
   else
   {
-    ecma_number_t end_num;
-
-    if (ECMA_IS_VALUE_ERROR (ecma_get_number (arg2, &end_num)))
+    if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (arg2,
+                                                                        len,
+                                                                        &end)))
     {
       return ECMA_VALUE_ERROR;
     }
-
-    end = ecma_builtin_helper_array_index_normalize (end_num, len, false);
   }
 
   JERRY_ASSERT (start <= len && end <= len);
@@ -1168,7 +1164,7 @@ ecma_builtin_string_prototype_object_substring (ecma_string_t *original_string_p
   /* 4, 6 */
   ecma_number_t start_num;
 
-  if (ECMA_IS_VALUE_ERROR (ecma_get_number (arg1, &start_num)))
+  if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (arg1, &start_num)))
   {
     return ECMA_VALUE_ERROR;
   }
@@ -1186,7 +1182,7 @@ ecma_builtin_string_prototype_object_substring (ecma_string_t *original_string_p
   {
     ecma_number_t end_num;
 
-    if (ECMA_IS_VALUE_ERROR (ecma_get_number (arg2, &end_num)))
+    if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (arg2, &end_num)))
     {
       return ECMA_VALUE_ERROR;
     }
@@ -1355,7 +1351,7 @@ ecma_builtin_string_prototype_object_repeat (ecma_string_t *original_string_p, /
 
   /* 4 */
   ecma_number_t count_number;
-  ecma_value_t count_value = ecma_get_number (repeat, &count_number);
+  ecma_value_t count_value = ecma_op_to_integer (repeat, &count_number);
 
   /* 5 */
   if (ECMA_IS_VALUE_ERROR (count_value))
@@ -1472,16 +1468,11 @@ ecma_builtin_string_prototype_object_substr (ecma_string_t *this_string_p, /**<
   /* 2. */
   ecma_number_t start_num;
 
-  if (ECMA_IS_VALUE_ERROR (ecma_get_number (start, &start_num)))
+  if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (start, &start_num)))
   {
     return ECMA_VALUE_ERROR;
   }
 
-  if (ecma_number_is_nan (start_num))
-  {
-    start_num = 0;
-  }
-
   /* 3. */
   ecma_number_t length_num = ecma_number_make_infinity (false);
 
@@ -1489,7 +1480,7 @@ ecma_builtin_string_prototype_object_substr (ecma_string_t *this_string_p, /**<
   {
     ecma_number_t len;
 
-    if (ECMA_IS_VALUE_ERROR (ecma_get_number (length, &len)))
+    if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (length, &len)))
     {
       return ECMA_VALUE_ERROR;
     }
diff --git a/jerry-core/ecma/builtin-objects/typedarray/ecma-builtin-typedarray-prototype.c b/jerry-core/ecma/builtin-objects/typedarray/ecma-builtin-typedarray-prototype.c
index d75f4c4349..99e0062fde 100644
--- a/jerry-core/ecma/builtin-objects/typedarray/ecma-builtin-typedarray-prototype.c
+++ b/jerry-core/ecma/builtin-objects/typedarray/ecma-builtin-typedarray-prototype.c
@@ -834,16 +834,11 @@ ecma_op_typedarray_set_with_typedarray (ecma_value_t this_arg, /**< this argumen
 {
   /* 6.~ 8. targetOffset */
   ecma_number_t target_offset_num;
-  if (ECMA_IS_VALUE_ERROR (ecma_get_number (offset_val, &target_offset_num)))
+  if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (offset_val, &target_offset_num)))
   {
     return ECMA_VALUE_ERROR;
   }
 
-  if (ecma_number_is_nan (target_offset_num))
-  {
-    target_offset_num = 0;
-  }
-
   if (target_offset_num <= -1.0 || target_offset_num >= (ecma_number_t) UINT32_MAX + 0.5)
   {
     return ecma_raise_range_error (ECMA_ERR_MSG ("Invalid offset"));
@@ -937,12 +932,14 @@ ecma_builtin_typedarray_prototype_set (ecma_value_t this_arg, /**< this argument
   }
 
   /* 6.~ 8. targetOffset */
-  ecma_value_t ret_val = ECMA_VALUE_EMPTY;
-  ECMA_OP_TO_NUMBER_TRY_CATCH (target_offset_num, offset_val, ret_val);
-  if (ecma_number_is_nan (target_offset_num))
+  ecma_number_t target_offset_num;
+  ecma_value_t ret_val = ecma_op_to_integer (offset_val, &target_offset_num);
+
+  if (ECMA_IS_VALUE_ERROR (ret_val))
   {
-    target_offset_num = 0;
+    return ret_val;
   }
+
   if (target_offset_num <= -1.0 || target_offset_num >= (ecma_number_t) UINT32_MAX + 0.5)
   {
     return ecma_raise_range_error (ECMA_ERR_MSG ("Invalid offset"));
@@ -1006,7 +1003,6 @@ ecma_builtin_typedarray_prototype_set (ecma_value_t this_arg, /**< this argument
 
   ECMA_FINALIZE (source_length);
   ECMA_FINALIZE (source_obj);
-  ECMA_OP_TO_NUMBER_FINALIZE (target_offset_num);
 
   if (ecma_is_value_empty (ret_val))
   {
@@ -1252,9 +1248,15 @@ ecma_builtin_typedarray_prototype_subarray (ecma_value_t this_arg, /**< this arg
   uint32_t begin_index_uint32 = 0, end_index_uint32 = 0;
 
   /* 7. relativeBegin */
-  ECMA_OP_TO_NUMBER_TRY_CATCH (relative_begin, begin, ret_value);
+  ecma_number_t relative_begin;
+
+  if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (begin, &relative_begin)))
+  {
+    return ECMA_VALUE_ERROR;
+  }
 
-  begin_index_uint32 = ecma_builtin_helper_array_index_normalize (relative_begin, info.length, false);
+  begin_index_uint32 = ((relative_begin < 0) ? (ecma_length_t) JERRY_MAX ((info.length + relative_begin), 0)
+                                             : (ecma_length_t) JERRY_MIN (relative_begin, info.length));
 
   if (ecma_is_value_undefined (end))
   {
@@ -1263,15 +1265,16 @@ ecma_builtin_typedarray_prototype_subarray (ecma_value_t this_arg, /**< this arg
   else
   {
     /* 10. relativeEnd */
-    ECMA_OP_TO_NUMBER_TRY_CATCH (relative_end, end, ret_value);
+    ecma_number_t relative_end;
 
-    end_index_uint32 = ecma_builtin_helper_array_index_normalize (relative_end, info.length, false);
-
-    ECMA_OP_TO_NUMBER_FINALIZE (relative_end);
+    if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (end, &relative_end)))
+    {
+      return ECMA_VALUE_ERROR;
+    }
+    end_index_uint32 = ((relative_end < 0) ? (ecma_length_t) JERRY_MAX ((info.length + relative_end), 0)
+                                           : (ecma_length_t) JERRY_MIN (relative_end, info.length));
   }
 
-  ECMA_OP_TO_NUMBER_FINALIZE (relative_begin);
-
   if (!ecma_is_value_empty (ret_value))
   {
     return ret_value;
@@ -1335,9 +1338,14 @@ ecma_builtin_typedarray_prototype_fill (ecma_value_t this_arg, /**< this argumen
 
   uint32_t begin_index_uint32 = 0, end_index_uint32 = 0;
 
-  ECMA_OP_TO_NUMBER_TRY_CATCH (relative_begin, begin, ret_value);
+  ecma_number_t relative_begin;
+  if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (begin, &relative_begin)))
+  {
+    return ECMA_VALUE_ERROR;
+  }
 
-  begin_index_uint32 = ecma_builtin_helper_array_index_normalize (relative_begin, info.length, false);
+  begin_index_uint32 = ((relative_begin < 0) ? (ecma_length_t) JERRY_MAX ((info.length + relative_begin), 0)
+                                             : (ecma_length_t) JERRY_MIN (relative_begin, info.length));
 
   if (ecma_is_value_undefined (end))
   {
@@ -1345,18 +1353,14 @@ ecma_builtin_typedarray_prototype_fill (ecma_value_t this_arg, /**< this argumen
   }
   else
   {
-    ECMA_OP_TO_NUMBER_TRY_CATCH (relative_end, end, ret_value);
-
-    end_index_uint32 = ecma_builtin_helper_array_index_normalize (relative_end, info.length, false);
-
-    ECMA_OP_TO_NUMBER_FINALIZE (relative_end);
-  }
-
-  ECMA_OP_TO_NUMBER_FINALIZE (relative_begin);
+    ecma_number_t relative_end;
+    if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (end, &relative_end)))
+    {
+      return ECMA_VALUE_ERROR;
+    }
 
-  if (!ecma_is_value_empty (ret_value))
-  {
-    return ret_value;
+    end_index_uint32 = ((relative_end < 0) ? (ecma_length_t) JERRY_MAX ((info.length + relative_end), 0)
+                                           : (ecma_length_t) JERRY_MIN (relative_end, info.length));
   }
 
   ecma_length_t subarray_length = 0;
@@ -1685,20 +1689,18 @@ ecma_builtin_typedarray_prototype_find_index (ecma_value_t this_arg, /**< this a
 } /* ecma_builtin_typedarray_prototype_find_index */
 
 /**
- * The %TypedArray%.prototype object's 'indexOf' and 'lastIndexOf' routine helper
+ * The %TypedArray%.prototype object's 'indexOf' routine
  *
  * See also:
- *         ECMA-262 v6, 22.2.3.13, 22.2.3.16
+ *         ECMA-262 v6, 22.2.3.13
  *
  * @return ecma value
  *         Returned value must be freed with ecma_free_value.
  */
 static ecma_value_t
-ecma_builtin_typedarray_prototype_index_helper (ecma_value_t this_arg, /**< this argument */
-                                                const ecma_value_t args[], /**< arguments list */
-                                                ecma_length_t args_number, /**< number of arguments */
-                                                bool is_last_index_of) /**< true - lastIndexOf routine
-                                                                         false - indexOf routine */
+ecma_builtin_typedarray_prototype_index_of (ecma_value_t this_arg, /**< this argument */
+                                           const ecma_value_t args[], /**< arguments list */
+                                           ecma_length_t args_number) /**< number of arguments */
 {
   if (!ecma_is_typedarray (this_arg))
   {
@@ -1715,6 +1717,7 @@ ecma_builtin_typedarray_prototype_index_helper (ecma_value_t this_arg, /**< this
   uint32_t limit = info.length * info.element_size;
   uint32_t from_index;
 
+   /* 5. */
   if (args_number == 0
       || !ecma_is_value_number (args[0])
       || info.length == 0)
@@ -1723,38 +1726,36 @@ ecma_builtin_typedarray_prototype_index_helper (ecma_value_t this_arg, /**< this
   }
   if (args_number == 1)
   {
-    from_index = is_last_index_of ? info.length - 1 : 0;
+    from_index = 0;
   }
   else
   {
+    /* 6. 7. */
     ecma_number_t num_var;
-
-    if (ECMA_IS_VALUE_ERROR (ecma_get_number (args[1], &num_var)))
+    if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (args[1], &num_var)))
     {
       return ECMA_VALUE_ERROR;
     }
-
-    if (!ecma_number_is_nan (num_var)
-        && is_last_index_of
-        && num_var < 0
-        && fabs (num_var) > info.length)
+    /* 8. */
+    if (num_var >= info.length)
     {
       return ecma_make_integer_value (-1);
     }
-    else
-    {
-      from_index = ecma_builtin_helper_array_index_normalize (num_var, info.length, is_last_index_of);
-    }
+
+    /* 9. 10. */
+    from_index = ((num_var >= 0) ? (uint32_t) num_var
+                                 : (uint32_t) (info.length + num_var));
   }
 
+
   ecma_number_t search_num = ecma_get_number_from_value (args[0]);
 
-  int32_t increment = is_last_index_of ? -info.element_size : info.element_size;
   ecma_typedarray_getter_fn_t getter_cb = ecma_get_typedarray_getter_fn (info.id);
 
+  /* 11. */
   for (int32_t position = (int32_t) from_index * info.element_size;
-       (is_last_index_of ? position >= 0 : (uint32_t) position < limit);
-       position += increment)
+       (uint32_t) position < limit;
+       position += info.element_size)
   {
     ecma_number_t element_num = getter_cb (info.buffer_p + position);
 
@@ -1764,24 +1765,8 @@ ecma_builtin_typedarray_prototype_index_helper (ecma_value_t this_arg, /**< this
     }
   }
 
+  /* 12. */
   return ecma_make_integer_value (-1);
-} /* ecma_builtin_typedarray_prototype_index_helper */
-
-/**
- * The %TypedArray%.prototype object's 'indexOf' routine
- *
- * See also:
- *         ECMA-262 v6, 22.2.3.13
- *
- * @return ecma value
- *         Returned value must be freed with ecma_free_value.
- */
-static ecma_value_t
-ecma_builtin_typedarray_prototype_index_of (ecma_value_t this_arg, /**< this argument */
-                                           const ecma_value_t args[], /**< arguments list */
-                                           ecma_length_t args_number) /**< number of arguments */
-{
-  return ecma_builtin_typedarray_prototype_index_helper (this_arg, args, args_number, false);
 } /* ecma_builtin_typedarray_prototype_index_of */
 
 /**
@@ -1798,40 +1783,72 @@ ecma_builtin_typedarray_prototype_last_index_of (ecma_value_t this_arg, /**< thi
                                                 const ecma_value_t args[], /**< arguments list */
                                                 ecma_length_t args_number) /**< number of arguments */
 {
-  return ecma_builtin_typedarray_prototype_index_helper (this_arg, args, args_number, true);
-} /* ecma_builtin_typedarray_prototype_last_index_of */
+  if (!ecma_is_typedarray (this_arg))
+  {
+    return ecma_raise_type_error (ECMA_ERR_MSG ("Argument 'this' is not a TypedArray."));
+  }
 
-/**
- * Helper function to get the uint32_t value from an argument.
- *
- * @return ecma value
- *         Returned value must be freed with ecma_free_value.
- */
-static ecma_value_t
-ecma_builtin_get_uint32_value_from_argument (ecma_value_t arg_value, /**< this argument */
-                                             uint32_t length, /**< length of the TypedArray */
-                                             uint32_t *index, /**< [out] pointer to the given index */
-                                             bool is_end_index) /**< true - normalize the end index */
-{
-  ecma_number_t num_var;
-  ecma_value_t ret_value = ecma_get_number (arg_value, &num_var);
+  ecma_object_t *typedarray_p = ecma_get_object_from_value (this_arg);
+  ecma_typedarray_info_t info = ecma_typedarray_get_info (typedarray_p);
+  if (ecma_arraybuffer_is_detached (info.array_buffer_p))
+  {
+    return ecma_raise_type_error (ECMA_ERR_MSG ("ArrayBuffer has been detached."));
+  }
+
+  uint32_t from_index;
 
-  if (ECMA_IS_VALUE_ERROR (ret_value))
+  /* 5. */
+  if (args_number == 0
+      || !ecma_is_value_number (args[0])
+      || info.length == 0)
   {
-    return ret_value;
+    return ecma_make_integer_value (-1);
   }
 
-  if (is_end_index && ecma_number_is_nan (num_var))
+  if (args_number == 1)
   {
-    *index = length;
+    from_index = info.length - 1;
   }
   else
   {
-    *index = ecma_builtin_helper_array_index_normalize (num_var, length, false);
+    /* 6. 7. */
+    ecma_number_t num_var;
+    if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (args[1], &num_var)))
+    {
+      return ECMA_VALUE_ERROR;
+    }
+
+    if (!ecma_number_is_nan (num_var)
+        && -num_var > info.length)
+    {
+      return ecma_make_integer_value (-1);
+    }
+
+    /* 8. 9. */
+    from_index = ((num_var >= 0) ? (uint32_t) JERRY_MIN (num_var, info.length - 1)
+                                 : (uint32_t) (info.length + num_var));
   }
 
-  return ECMA_VALUE_EMPTY;
-} /* ecma_builtin_get_uint32_value_from_argument */
+  ecma_number_t search_num = ecma_get_number_from_value (args[0]);
+
+  ecma_typedarray_getter_fn_t getter_cb = ecma_get_typedarray_getter_fn (info.id);
+
+  /* 10. */
+  for (int32_t position = (int32_t) from_index * info.element_size;
+       position >= 0;
+       position += -info.element_size)
+  {
+    ecma_number_t element_num = getter_cb (info.buffer_p + position);
+
+    if (search_num == element_num)
+    {
+      return ecma_make_number_value ((ecma_number_t) position / info.element_size);
+    }
+  }
+
+  /* 11. */
+  return ecma_make_integer_value (-1);
+} /* ecma_builtin_typedarray_prototype_last_index_of */
 
 /**
  * The %TypedArray%.prototype object's 'copyWithin' routine
@@ -1854,61 +1871,52 @@ ecma_builtin_typedarray_prototype_copy_within (ecma_value_t this_arg, /**< this
 
   ecma_object_t *typedarray_p = ecma_get_object_from_value (this_arg);
   ecma_typedarray_info_t info = ecma_typedarray_get_info (typedarray_p);
-  uint32_t target = 0;
-  uint32_t start = 0;
-  uint32_t end = info.length;
+  uint32_t relative_target = 0;
+  uint32_t relative_start = 0;
+  uint32_t relative_end = info.length;
 
   if (args_number > 0)
   {
-    ecma_value_t target_value = ecma_builtin_get_uint32_value_from_argument (args[0],
-                                                                             info.length,
-                                                                             &target,
-                                                                             false);
-
-    if (ECMA_IS_VALUE_ERROR (target_value))
+    if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (args[0],
+                                                                        info.length,
+                                                                        &relative_target)))
     {
-      return target_value;
+      return ECMA_VALUE_ERROR;
     }
 
     if (args_number > 1)
     {
-      ecma_value_t start_value = ecma_builtin_get_uint32_value_from_argument (args[1],
-                                                                              info.length,
-                                                                              &start,
-                                                                              false);
-
-      if (ECMA_IS_VALUE_ERROR (start_value))
+      if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (args[1],
+                                                                          info.length,
+                                                                          &relative_start)))
       {
-        return start_value;
+        return ECMA_VALUE_ERROR;
       }
 
-      if (args_number > 2)
+      if (args_number > 2 && args[2] != ECMA_VALUE_UNDEFINED)
       {
-        ecma_value_t end_value = ecma_builtin_get_uint32_value_from_argument (args[2],
-                                                                              info.length,
-                                                                              &end,
-                                                                              true);
-
-        if (ECMA_IS_VALUE_ERROR (end_value))
+        if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (args[2],
+                                                                            info.length,
+                                                                            &relative_end)))
         {
-          return end_value;
+          return ECMA_VALUE_ERROR;
         }
       }
     }
   }
 
-  if (target >= info.length || start >= end || end == 0)
+  if (relative_target >= info.length || relative_start >= relative_end || relative_end == 0)
   {
     return ecma_copy_value (this_arg);
   }
   else
   {
-    uint32_t distance = end - start;
-    uint32_t offset = info.length - target;
+    uint32_t distance = relative_end - relative_start;
+    uint32_t offset = info.length - relative_target;
     uint32_t count = JERRY_MIN (distance, offset);
 
-    memmove (info.buffer_p + (target * info.element_size),
-             info.buffer_p + (start * info.element_size),
+    memmove (info.buffer_p + (relative_target * info.element_size),
+             info.buffer_p + (relative_start * info.element_size),
              (size_t) (count * info.element_size));
   }
 
@@ -1942,36 +1950,29 @@ ecma_builtin_typedarray_prototype_slice (ecma_value_t this_arg, /**< this argume
   }
 
   ecma_typedarray_info_t info = ecma_typedarray_get_info (typedarray_p);
-  uint32_t start = 0;
-  uint32_t end = info.length;
+  uint32_t relative_start = 0;
+  uint32_t relative_end = info.length;
 
   if (args_number > 0)
   {
-    ecma_value_t start_value = ecma_builtin_get_uint32_value_from_argument (args[0],
-                                                                            info.length,
-                                                                            &start,
-                                                                            false);
-
-    if (ECMA_IS_VALUE_ERROR (start_value))
+    if (ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (args[0],
+                                                                        info.length,
+                                                                        &relative_start)))
     {
-      return start_value;
+      return ECMA_VALUE_ERROR;
     }
 
-    if (args_number > 1)
+    if (args_number > 1
+        && args[1] != ECMA_VALUE_UNDEFINED
+        && ECMA_IS_VALUE_ERROR (ecma_builtin_helper_array_index_normalize (args[1],
+                                                                           info.length,
+                                                                           &relative_end)))
     {
-      ecma_value_t end_value = ecma_builtin_get_uint32_value_from_argument (args[1],
-                                                                            info.length,
-                                                                            &end,
-                                                                            true);
-
-      if (ECMA_IS_VALUE_ERROR (end_value))
-      {
-        return end_value;
-      }
+      return ECMA_VALUE_ERROR;
     }
   }
 
-  int32_t distance = (int32_t) (end - start);
+  int32_t distance = (int32_t) (relative_end - relative_start);
   uint32_t count = distance > 0 ? (uint32_t) distance : 0;
 
   ecma_value_t new_typedarray = ecma_op_create_typedarray_with_type_and_length (typedarray_p, count);
@@ -1986,7 +1987,7 @@ ecma_builtin_typedarray_prototype_slice (ecma_value_t this_arg, /**< this argume
     ecma_object_t *new_typedarray_p = ecma_get_object_from_value (new_typedarray);
 
     lit_utf8_byte_t *new_typedarray_buffer_p = ecma_typedarray_get_buffer (new_typedarray_p);
-    uint32_t src_byte_index = (start * info.element_size);
+    uint32_t src_byte_index = (relative_start * info.element_size);
 
     memcpy (new_typedarray_buffer_p,
             info.buffer_p + src_byte_index,
diff --git a/jerry-core/ecma/operations/ecma-dataview-object.c b/jerry-core/ecma/operations/ecma-dataview-object.c
index 7e2b2d7ace..e29985eb03 100644
--- a/jerry-core/ecma/operations/ecma-dataview-object.c
+++ b/jerry-core/ecma/operations/ecma-dataview-object.c
@@ -67,15 +67,17 @@ ecma_op_dataview_create (const ecma_value_t *arguments_list_p, /**< arguments li
 
   if (arguments_list_len > 1)
   {
-    ecma_number_t number_offset;
-    ecma_value_t number_offset_value = ecma_get_number (arguments_list_p[1], &number_offset);
-
-    if (ECMA_IS_VALUE_ERROR (number_offset_value))
+    ecma_number_t number_offset, offset_num;
+    if (ECMA_IS_VALUE_ERROR (ecma_get_number (arguments_list_p[1], &number_offset)))
+    {
+      return ECMA_VALUE_ERROR;
+    }
+    if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (arguments_list_p[1], &offset_num)))
     {
-      return number_offset_value;
+      return ECMA_VALUE_ERROR;
     }
 
-    offset = ecma_number_to_int32 (number_offset);
+    offset = (int32_t) offset_num;
 
     /* 7. */
     if (number_offset != offset || offset < 0)
@@ -240,7 +242,7 @@ ecma_op_dataview_get_set_view_value (ecma_value_t view, /**< the operation's 'vi
 
   /* 3 - 5. */
   ecma_number_t number_index;
-  ecma_value_t number_index_value = ecma_get_number (request_index, &number_index);
+  ecma_value_t number_index_value = ecma_op_to_integer (request_index, &number_index);
 
   if (ECMA_IS_VALUE_ERROR (number_index_value))
   {
diff --git a/jerry-core/ecma/operations/ecma-regexp-object.c b/jerry-core/ecma/operations/ecma-regexp-object.c
index 803323161f..8a2acd346c 100644
--- a/jerry-core/ecma/operations/ecma-regexp-object.c
+++ b/jerry-core/ecma/operations/ecma-regexp-object.c
@@ -1200,7 +1200,8 @@ ecma_regexp_exec_helper (ecma_value_t regexp_value, /**< RegExp object */
     ecma_value_t lastindex_value = ecma_op_object_get_own_data_prop (regexp_object_p, lastindex_str_p);
 
     ecma_number_t lastindex_num;
-    ret_value = ecma_get_number (lastindex_value, &lastindex_num);
+    ret_value = ecma_op_to_integer (lastindex_value, &lastindex_num);
+
     ecma_free_value (lastindex_value);
 
     if (ECMA_IS_VALUE_ERROR (ret_value))
@@ -1217,7 +1218,7 @@ ecma_regexp_exec_helper (ecma_value_t regexp_value, /**< RegExp object */
       lastindex_num = input_length + 1;
 #endif /* ENABLED (JERRY_ES2015) */
     }
-    index = ecma_number_to_uint32 (lastindex_num);
+    index = (uint32_t) lastindex_num;
 
     if (index > input_length)
     {
diff --git a/jerry-core/ecma/operations/ecma-typedarray-object.c b/jerry-core/ecma/operations/ecma-typedarray-object.c
index befb59691b..6568e135d3 100644
--- a/jerry-core/ecma/operations/ecma-typedarray-object.c
+++ b/jerry-core/ecma/operations/ecma-typedarray-object.c
@@ -949,10 +949,13 @@ ecma_op_create_typedarray (const ecma_value_t *arguments_list_p, /**< the arg li
       ecma_value_t arg3 = ((arguments_list_len > 2) ? arguments_list_p[2]
                                                     : ECMA_VALUE_UNDEFINED);
 
-      ECMA_OP_TO_NUMBER_TRY_CATCH (num2, arg2, ret);
-      uint32_t offset = ecma_number_to_uint32 (num2);
+      ecma_number_t offset;
+      if (ECMA_IS_VALUE_ERROR (ecma_op_to_integer (arg2, &offset)))
+      {
+        return ECMA_VALUE_ERROR;
+      }
 
-      if (ecma_number_is_negative (ecma_number_to_int32 (num2)) || (offset % (uint32_t) (1 << element_size_shift) != 0))
+      if (ecma_number_is_negative (offset))
       {
         ret = ecma_raise_range_error (ECMA_ERR_MSG ("Invalid offset."));
       }
@@ -1007,15 +1010,13 @@ ecma_op_create_typedarray (const ecma_value_t *arguments_list_p, /**< the arg li
         {
           ecma_length_t array_length = new_byte_length >> element_size_shift;
           ret = ecma_typedarray_create_object_with_buffer (arraybuffer_p,
-                                                           offset,
+                                                           (ecma_length_t) offset,
                                                            array_length,
                                                            proto_p,
                                                            element_size_shift,
                                                            typedarray_id);
         }
       }
-
-      ECMA_OP_TO_NUMBER_FINALIZE (num2);
     }
     else
     {
diff --git a/tests/jerry/es2015/dataview.js b/tests/jerry/es2015/dataview.js
index 6faa2bc3fb..020a1e8986 100644
--- a/tests/jerry/es2015/dataview.js
+++ b/tests/jerry/es2015/dataview.js
@@ -168,11 +168,10 @@ gettersSetters.forEach (function (propName) {
   var view = new DataView (buffer)
 
   /* ES2015 24.2.1.{1, 2}.6 (numberIndex != getIndex) */
-  try {
-    view[propName] (1.5);
-    assert (false);
-  } catch (e) {
-    assert (e instanceof RangeError);
+  if (propName.indexOf("get") !== -1) {
+    assert(view[propName] (1.5) === 0);
+  } else {
+    assert(view[propName] (1.5) === undefined);
   }
 
   /* ES2015 24.2.1.{1, 2}.6 (getIndex < 0) */
diff --git a/tests/jerry/regression-test-issue-3325.js b/tests/jerry/regression-test-issue-3325.js
new file mode 100644
index 0000000000..7a0878249a
--- /dev/null
+++ b/tests/jerry/regression-test-issue-3325.js
@@ -0,0 +1,19 @@
+// Copyright JS Foundation and other contributors, http://js.foundation
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+var text = 'x';
+var index = Math.random () - 1;
+assert (text.charAt(0) === "x");
+assert (text.charAt(index) === "x");
+assert (text.charAt(index) !== "");
